var selectedDn="";
var selectedVV="";
var selectedArea="";
var treeAreas=new Array();
var search="";
var scope="one";
	
function showDiv(id) {
    document.getElementById(id).style.visibility="visible";
    document.getElementById(id).style.position="relative";
}

function hideDiv(id) {
    document.getElementById(id).style.visibility="hidden";
    document.getElementById(id).style.position="absolute";
}

function setInitValues() {
	document.getElementById("serverName").innerHTML=config.servername;
	document.getElementById("textContent").innerHTML=getLoadingPanel();
	setDefaultLangHeaders();
	setDefaultVirtualView();
}

function setVirtualView(virtualView) {
    selectedVV=new CopaVirtualViewNav();
    selectedVV.parseDOM(virtualView);
    document.getElementById("vvName").innerHTML=selectedVV.name;
	startVV();		   	
}

function selectVV(dnVV) {
	var url=config.baseWS+"copaManager.php?oper=listVirtualViews&dn="+encode64(config.dnbase);
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
            var xml=request.responseXML;
            var vvs=xml.getElementsByTagName("VirtualView");
            for (var i=0; i<vvs.length; i++) {
            	if (vvs[i].getAttribute("dn")==dnVV) {
            		setVirtualView(vvs[i]);
					i=vvs.length;
            	}
            }
        }
    }
    request.send(null);
}

function setDefaultVirtualView() {
	var url=config.baseWS+"copaManager.php?oper=listVirtualViews&dn="+encode64(config.dnbase);
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
            var xml=request.responseXML;
            var vvs=xml.getElementsByTagName("VirtualView");
            var selVV=vvs[0];
            for (var i=1; i<vvs.length; i++) {
            	if (vvs[i].getAttribute("default")=="true") {
            		selVV=vvs[i];
            	}
            }
       		setVirtualView(selVV);
        }
    }
    request.send(null);
}

function showVVs() {
	cleanSelections();
	selectedVV="";
	updateNavigation();
    document.getElementById("vvName").innerHTML="";
    document.getElementById("selectedArea").innerHTML=getI18N("area");
    document.getElementById("entryContent").innerHTML=getLoadingPanel();
    hideDiv("areasBox");
    hideDiv("childBox");
	var url=config.baseWS+"copaManager.php?oper=listVirtualViews&dn="+encode64(config.dnbase);
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
	    	var res="";
            var xml=request.responseXML;
            var vvs=xml.getElementsByTagName("VirtualView");
            for (var i=0; i<vvs.length; i++) {
            	var vv=new CopaVirtualViewNav();
            	vv.parseDOM(vvs[i]);
            			res=res+"<div class='childItem'>";
        	    		res=res+getI18N("virtualView")+":&nbsp;"+"<a href='javascript:selectVV(\""+vv.dn+"\");'>"+vv.name+"</a>";
	    	        	res=res+"</div>";
            }
    document.getElementById("entryContent").innerHTML=res;
        }
    }
    request.send(null);
}

function updateNavigation() {
	var res="<ul>";
	res = res + "<li><a href='javascript:showVVs();'>"+getI18N("virtualViews")+"</a></li>";
	if (selectedVV&&selectedVV.name) {
		res = res + "<li><a href='javascript:startVV(\""+selectedVV.dn+"\");'>"+selectedVV.name+"</a></li>";
	}
	for (var i=0; i<treeAreas.length; i++) {
       	res=res+"<li><a href=\"javascript:selectArea('"+treeAreas[i][0]+"','"+treeAreas[i][1]+"');\">"+treeAreas[i][1]+"</a></li>";
	}
	if (selectedDn!="") {
		res = res + "<li><a href='javascript:selectDN(\""+selectedDn+"\");'>"+selectedDn+"</a></li>";
	}
	res = res + "</ul>";
	document.getElementById("textContent").innerHTML=res;

	var res2="";
	for (var i=0 ; i<config.i18n.length;i++) {
		if (config.sel_i18n==config.i18n[i]) {
			res2 = res2 + "<span>"+config.i18n[i]+"</span>";
		}
		else {
			res2 = res2 + "<span><a href='javascript:setLang(\""+config.i18n[i]+"\");'>"+config.i18n[i]+"</a></span>";
		}
		if (i<(config.i18n.length-1)) {
			res2 = res2 + "&nbsp;<span class='horSep'>|</span>&nbsp;";
		}
	}
    
	document.getElementById("langContent").innerHTML=res2;
}

function setLang(num){
     config.language = config.i18n[num];
     config.sel_i18n=num;
     setDefaultLangHeaders();
     setInitValues()
}

function setDefaultLangHeaders(){
     document.getElementById("navigation").innerHTML=getI18N("navigation");
     document.getElementById("virtualView").innerHTML=getI18N("virtualView");
     document.getElementById("connLdap").innerHTML=getI18N("connLdap");
     document.getElementById("titleNavega").innerHTML=getI18N("titleNavega");
     document.getElementById("subareas").innerHTML=getI18N("subareas");
     document.getElementById("selectedArea").innerHTML=getI18N("selectedArea");
     document.getElementById("contInfo").innerHTML=getI18N("contInfo");

}

function cleanSelections() {
	selectedArea="";
	treeAreas.splice(0,treeAreas.length);
	showDiv("areasBox");
	showDiv("childBox");
    selectedDn="";
}

function startVV() {
	cleanSelections();
   	updateNavigation();
   	updateSelectedArea();
   	updateSubAreas();
	updateChildsInfo();
}

function updateSelectedArea() {
	if (selectedArea=="") {
		showInfoVV();
	}
	else {
		showInfoArea();
	}
}

function showInfoVV() {
    document.getElementById("selectedArea").innerHTML=getI18N("virtualView")+" "+selectedVV.name; 
    var content="";
	content=content+"<div class='firstEntryAttribute'>";
   	content=content+"	<div class='nameAttr'>"+getI18N("virtualView")+"</div>";
	content=content+"	<div class='valueAttr'>"
    content=content+"	    <div class='itemValueAttr'>";
	content=content+selectedVV.name;
	content=content+"       </div>";
    content=content+"	</div>";
	content=content+"</div>";
	content=content+"<div class='entryAttribute'>";
   	content=content+"	<div class='nameAttr'>"+getI18N("description")+"</div>";
	content=content+"	<div class='valueAttrTwo'>"
    content=content+"	    <div class='itemValueAttr'>";
	content=content+selectedVV.description;
	content=content+"       </div>";
    content=content+"	</div>";
	content=content+"</div>";
	document.getElementById("entryContent").innerHTML=content;
}

function showInfoArea() {
    document.getElementById("selectedArea").innerHTML=getI18N("area"); 
    document.getElementById("entryContent").innerHTML=getLoadingPanel();
	var url=config.baseWS+"copaManager.php?oper=getArea&dnVV="+encode64(selectedVV.dn)+"&copaCodeArea="+selectedArea;
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
            var xml=request.responseXML;
            var areas=xml.getElementsByTagName("Area");
            var areaInfo = new CopaArea();
            areaInfo.parseDOM(areas[0]);
		    document.getElementById("selectedArea").innerHTML=getI18N("area")+" "+areaInfo.name; 
			document.getElementById("entryContent").innerHTML=getAreaInfoHTML(areaInfo);
        }
    }
    request.send(null);
}

function getAreaInfoHTML(areaInfo) {
		    var content="";
			content=content+"<div class='firstEntryAttribute'>";
		   	content=content+"	<div class='nameAttr'>Nombre</div>";
			content=content+"	<div class='valueAttr'>"
		    content=content+"	    <div class='itemValueAttr'>";
			content=content+areaInfo.name;
			content=content+"       </div>";
		    content=content+"	</div>";
			content=content+"</div>";
			content=content+"<div class='entryAttribute'>";
		   	content=content+"	<div class='nameAttr'>Description</div>";
			content=content+"	<div class='valueAttrTwo'>"
		    content=content+"	    <div class='itemValueAttr'>";
			content=content+areaInfo.description;
			content=content+"       </div>";
		    content=content+"	</div>";
			content=content+"</div>";
			if (areaInfo.related.length>0) {
				content=content+"<div class='entryAttribute'>";
			   	content=content+"	<div class='nameAttr'>&Aacute;reas relacionadas</div>";
				content=content+"	<div class='valueAttr'>"
			    for (var i=0; i<areaInfo.related.length; i++) {
			    	content=content+"	    <div class='itemValueAttr'>";
					content=content+getPrintRelatedArea(areaInfo.related[i]);
					content=content+"       </div>";
				}
			    content=content+"	</div>";
				content=content+"</div>";
			}
			return content;
}

function selectExternVV(dnVV,copaCode) {
	var re=new RegExp("([a-z][0-9]+)+","g");
	var m=re.exec(copaCode);
	if (m == null) {
  	} else {
  		var copaCodes=m[1];
  		selectedArea=copaCodes;
    	for (i = 2; i < m.length; i++) {
      		copaCodes = copaCodes + "," + copaCodes + m[i];
      		selectedArea=m[i];
    	}
    document.getElementById("selectedArea").innerHTML=getI18N("area"); 
    document.getElementById("entryContent").innerHTML=getLoadingPanel();
	document.getElementById("textContent").innerHTML=getLoadingPanel();
	var url=config.baseWS+"copaManager.php?oper=getArea&dnVV="+encode64(dnVV)+"&copaCodeArea="+copaCodes+"&includeVV=1";
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
            var xml=request.responseXML;
            var areas=xml.getElementsByTagName("Area");
           	treeAreas.splice(0,treeAreas.length);
            for (var i=0; i<areas.length; i++) {
	            var areaInfo = new CopaArea();
    	        areaInfo.parseDOM(areas[i]);
				treeAreas[treeAreas.length]=[areaInfo.copaCode,areaInfo.name];
    	        if (areaInfo.copaCode==copaCode) {
					document.getElementById("selectedArea").innerHTML=getI18N("area")+" "+areaInfo.name; 
					document.getElementById("entryContent").innerHTML=getAreaInfoHTML(areaInfo);
				}
			}
            var vvs=xml.getElementsByTagName("VirtualView");
            selectedVV=new CopaVirtualViewNav();
            selectedVV.parseDOM(vvs[0]);
            updateNavigation();
        }
    }
    request.send(null);

    }
}

function getPrintRelatedArea(urnArea) {
	var res="<div id='"+urnArea+"'>Loading...</div>";
	var url=config.baseWS+"copaManager.php?oper=getArea&urnArea="+encode64(urnArea)+"&includeVV=1";
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
            var xml=request.responseXML;
            var areas=xml.getElementsByTagName("Area");
            var areaInfo = new CopaArea();
            areaInfo.parseDOM(areas[0]);
            var vvs=xml.getElementsByTagName("VirtualView");
            var vv=new CopaVirtualViewNav();
            vv.parseDOM(vvs[0]);
	
			document.getElementById(urnArea).innerHTML="<a href='javascript:selectExternVV(\""+vv.dn+"\",\""+areaInfo.copaCode+"\");'>"+areaInfo.name+"</a> en la vista virtual <a href='javascript:selectVV(\""+vv.dn+"\");'>"+vv.name+"</a>";
        }
    }
    request.send(null);
    return res;
}

function updateSubAreas() {
    showDiv("areasBox");
    document.getElementById("areasContent").innerHTML=getLoadingPanel();
	var url=config.baseWS+"copaManager.php?oper=listAreas&dnVV="+encode64(selectedVV.dn);
	if (selectedArea!="") {
		url=url+"&copaCodeArea="+selectedArea;
	}
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
	    	var res="<ul>";
            var xml=request.responseXML;
            var areas=xml.getElementsByTagName("Area");
            if (areas.length==0) {
            	hideDiv("areasBox");
            }
            for (var i=0; i<areas.length; i++) {
            	var areaInfo=new CopaArea();
            	areaInfo.parseDOM(areas[i]);
            	res=res+"<li><a href=\"javascript:selectArea('"+areaInfo.copaCode+"','"+areaInfo.name+"');\">"+areaInfo.name+"</a></li>";
            }
            res=res+"</ul>";
		    document.getElementById("areasContent").innerHTML=res;
        }
    }
    request.send(null);
}

function getLoadingPanel() {
	var res="<div>Cargando...</div>";
	
	return res;
}

function selectArea(copaCodeArea,nameArea) {
	selectedArea=copaCodeArea;
	var found=false;
	for (var i=0; i<treeAreas.length; i++) {
		if (treeAreas[i][0]==copaCodeArea&&treeAreas[i][1]==nameArea) {
			treeAreas.splice(i+1,treeAreas.length-(i+1));
			found=true;
		}
	}
	if (found==false) {
		treeAreas[treeAreas.length]=[copaCodeArea,nameArea];
	}
    showDiv("areasBox");
    showDiv("childBox");
    selectedDn="";
   	updateNavigation();
   	updateSelectedArea();
	updateSubAreas();
	updateChildsInfo();
}

function updateChildsInfo() {
	if (selectedArea=="") {
		hideDiv("childBox");
	}
	else {
		showDiv("childBox");
	    document.getElementById("childContent").innerHTML=getLoadingPanel();
		var url=config.baseWS+"copaManager.php?oper=listResources&dnbase="+encode64(config.dnbase)+"&dnVV="+encode64(selectedVV.dn)+"&copaCodeArea="+selectedArea;
		if (typeof config.language!='undefined') {
			url=url+"&lang="+config.language;
		}
	    var request = new XmlHttpObject().getXmlHttp();
    	request.open('GET', url, true);
	    request.onreadystatechange = function() {
		    if (request.readyState == 4) {
	    		var res="";
            	var xml=request.responseXML;
	            var entries=xml.getElementsByTagName("Entry");
    	        if (entries.length==0) {
					hideDiv("childBox");
            	}
	            else {
					showDiv("childBox");
	    	        for (var i=0; i<entries.length; i++) {
            			var dnEntry=entries[i].getAttribute("dn");
            			var outputEntry=dnEntry;
        	    		var found=false;
	    	        	var attrs=entries[i].getElementsByTagName("Attribute");
		            	for (var j=0; j<attrs.length&&found==false; j++) {
        	    			var nameAttr=attrs[j].getAttribute("name");
            				for (var k=0; k<config.defaultSearchedAttrs.length&&found==false; k++) {
        	    				if (config.defaultSearchedAttrs[k]==nameAttr) {
    	        					found=true;
	            					var values=attrs[j].getElementsByTagName("AttributeValue");
            						outputEntry=values[0].getAttribute("value");
	            				}
    	        			}
        	    		}
            			res=res+"<div class='childItem'>";
        	    		res=res+getI18N(nameAttr)+":&nbsp;"+"<a href='javascript:selectDN(\""+dnEntry+"\");'>"+outputEntry+"</a>";
	    	        	res=res+"</div>";
		            }
        	    }
		    	document.getElementById("childContent").innerHTML=res;
	        }
    	}
	    request.send(null);
    }
}

function getI18N(name) {
	var res=name;
	if (!(i18n[name]==undefined)&&!(i18n[name][config.sel_i18n]==undefined)) {
		res=i18n[name][config.sel_i18n];
	}
	return res;
}

function selectDN(dn) {
	this.selectedDn=dn;
	updateNavigation();
	hideDiv("areasBox");
	hideDiv("childBox");
	document.getElementById("selectedArea").innerHTML=dn;
    document.getElementById("entryContent").innerHTML=getLoadingPanel();
	var url=config.baseWS+"getEntry.php?dn="+encode64(selectedDn);
	if (typeof config.language!='undefined') {
		url=url+"&lang="+config.language;
	}
    var request = new XmlHttpObject().getXmlHttp();
    request.open('GET', url, true);
    request.onreadystatechange = function() {
	    if (request.readyState == 4) {
	    	var res="";
            var xml=request.responseXML;
            var attributes=xml.getElementsByTagName("Attribute");
            var first=0;
            for (var i=0; i<attributes.length; i++) {
            	var name=attributes[i].getAttribute("name");
            	var parsedName=name;
            	if (name.indexOf(";")>=0) {
            		parsedName=name.substr(0,name.indexOf(";"));
            	}
            	if (isVisibleAttribute(name)) {
            		if (first==0) {
            			res=res+"<div class='firstEntryAttribute'>";
            		}
            		else {
            			res=res+"<div class='entryAttribute'>";
            		}
           			first=first+1;
	            	res=res+"	<div class='nameAttr'>"+getI18N(name)+"</div>";
	            	if (first%2==0) {
    	        		res=res+"	<div class='valueAttr'>"
    	        	}
    	        	else {
    	        		res=res+"	<div class='valueAttrTwo'>"
    	        	}
       	    		var values=attributes[i].getElementsByTagName("AttributeValue");
            		for (var j=0; j<values.length; j++) {
            			res=res+"	<div class='itemValueAttr'>";
            			if (values[j].hasAttribute("lang")) {
            				res=res+"<span class='itemValueAttrLang'>["+values[j].getAttribute("lang")+"]</span>&nbsp;";
            			}
            			var val=values[j].getAttribute("value");
            			if (viewAttribute[parsedName]) {
    		        		res=res+(viewAttribute[parsedName](name,val));
    		        	}
    	    	    	else {
	            			res=res+(values[j].getAttribute("value"));
		            	}
		            	res=res+"</div>";
	            	}
    	        	res=res+"	</div>";
					res=res+"</div>";
				}
            }
            document.getElementById("entryContent").innerHTML=res;
        }
    }
    request.send(null);
 }

 function isVisibleAttribute(name) {
 	var res=false;
 	for (var i=0; i<visibleAttributes.length&&res==false; i++) {
 		res=(visibleAttributes[i]==name);
 	}
 	return res;
 }
